/*  briefomat
 *  Copyright (C) 1999 Stefan Heimers (stefan.heimers@kosta.ch)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 
 *  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <string.h>
#include <gtk/gtk.h>
#include "briefomat.h"

GtkWidget *mbrwin;
GtkWidget *mbr_vbox;
GtkWidget *addresslist;
GtkWidget *mbr_button_hbox;
GtkWidget *printall_button;
GtkWidget *loadfile_button;
GtkWidget *savefile_button;
GtkWidget *db_button;
char *list;


char *get_firstname(char *string)
{
  char *buffer;
  unsigned int length=0;
  while (isalnum(string[length]) /* *(string[i]!='\0')*string[i]!='\n' */ )
    length++;
  buffer=(char *)malloc(length);
  strncpy(buffer,string,length);
  buffer[length]='\0';
  return buffer;
}

int print_them()
{
  char anrede[1000],anrede_full[1000],adr_buffer[1000];
  unsigned int strpos=0,i;
  char finished=0,*end;
  
  list = gtk_editable_get_chars((GtkEditable*) addresslist ,0,-1);
  end=list+strlen(list);
  gtk_text_insert( (GtkText *)addresslist,NULL,NULL, NULL,"\n<end>\n",-1 );
  strcpy(anrede,gtk_entry_get_text((GtkEntry*) anrede_feld ));
  while(!finished)
    { 
      if(list !=0)
	while (!isalnum(list[0])*(list[0]!='\0'))  //advance to first character of the next name
	  list++;
      else return 1;
      strcpy(anrede_full , anrede);
      strcat(anrede_full,get_firstname(list));
      gtk_entry_set_text((GtkEntry *) anrede_feld,(const gchar *) anrede_full );
      i=0;
      while ( (list[i]!='<')*(i<999) ) //until next adress entry and limit to 999 chars
	{
	  adr_buffer[i]=list[i];
	  i++;
	}
      adr_buffer[i]='\0';
      gtk_text_backward_delete(adresse_feld,gtk_text_get_length (adresse_feld));
      gtk_text_insert( (GtkText *)adresse_feld,NULL,NULL, NULL,adr_buffer,-1 );
      list += i;
      list = next_line(list);
      if (list >= end)
	finished=1;
      do_print_thread();
    }
  gtk_entry_set_text((GtkEntry *) anrede_feld,(const gchar *) anrede );
  
  return 0;
}

void massenbrief()
{
  //Massenbrief Dialogwindow
  mbrwin= gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (mbrwin), "Briefomat - Massenbrief");
  mbr_vbox=gtk_vbox_new(0, 0);
  gtk_container_add (GTK_CONTAINER (mbrwin), mbr_vbox);
  mbr_button_hbox=gtk_hbox_new(0,0);
  
  addresslist = gtk_text_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (mbr_vbox), addresslist, TRUE, TRUE, 0);
  gtk_widget_set_usize (addresslist, 100, 400);
  gtk_text_set_editable (GTK_TEXT (addresslist), TRUE);


  gtk_box_pack_start (GTK_BOX (mbr_vbox), mbr_button_hbox, 0, 0, 0);
  printall_button = gtk_button_new_with_label ("alle drucken");
  gtk_signal_connect(GTK_OBJECT (printall_button),   \
	    "clicked", (GtkSignalFunc) print_them, NULL);
  gtk_box_pack_start (GTK_BOX (mbr_button_hbox), printall_button, 0, 0, 0);
  db_button = gtk_button_new_with_label ("Adressen aus Datenbank lesen");
  gtk_signal_connect(GTK_OBJECT (db_button),   \
	    "clicked", (GtkSignalFunc) dbdialog, NULL);
  gtk_box_pack_start (GTK_BOX (mbr_button_hbox), db_button, 0, 0, 0);

 
  gtk_widget_show(addresslist);
  gtk_widget_show(printall_button);
  gtk_widget_show(db_button);
  gtk_widget_show(mbr_button_hbox);
  gtk_widget_show(mbr_vbox);
  gtk_widget_show(mbrwin);
}





